import zope.component
from zope.publisher.interfaces import NotFound
from zope.browserpage.viewpagetemplatefile import ViewPageTemplateFile

import z3c.form.field
import z3c.form.form

from Products.CMFCore.utils import getToolByName

from pmr2.app.browser import form
from pmr2.app.browser import page


class TermListing(page.TraversePage):
    """\
    Wraps an object around the mathml view.
    """

    template = ViewPageTemplateFile('termlist.pt')

    # XXX test
    search_key = 'cmeta_citation_id'

    def update(self):

        def clean_searchterm():
            if not hasattr(self, 'searchterm') or self.searchterm is None:
                self.searchterm = None
                return False
            self.searchterm = self.searchterm.replace(' ', '_')
            return True

        def build_saved_searches():
            q = {
                # XXX figure this out
                'query': '/',
            }
            self.saved_searches = [] #pt(path=q)

        def build_results():
            d = {}
            d[self.search_key] = self.searchterm
            self.all_results = pt(**d)
            if not self.all_results:
                raise NotFound(self.context, '', self.request)

        def build_terms():
            try:
                self.all_terms = \
                    pt.Indexes[self.search_key].uniqueValues()
            except NotImplementedError:
                pass

        pt = getToolByName(self.context, 'portal_catalog')
        if self.search_key not in pt.Indexes:
            # Nothing is set.
            return

        self.catalog_index = self.search_key
        self.searchterm = None
        if 'request_subpath' in self.request:
            self.searchterm = '/'.join(self.request['request_subpath'])

        # now call the methods to set the variables for the template.
        if clean_searchterm():
            build_results()
        else:
            build_saved_searches()
            # XXX remove items that are saved?
            build_terms()
